#ifndef MSP_CORE_SYSTEMERROR_H_
#define MSP_CORE_SYSTEMERROR_H_

#include <stdexcept>
#include <string>

namespace Msp {

class system_error: public std::runtime_error
{
private:
	int m_code;

public:
	system_error(const std::string &, int = -1);
	system_error(const std::string &, const std::string &);

	int code() const noexcept { return m_code; }

private:
	static std::string get_message(int);
};

} // namespace Msp

#endif
