#include "except.h"
#include "thread.h"
#include "thread_private.h"

using namespace std;

namespace Msp {

Thread::Thread(const string &name):
	_priv(new Private),
	_name(name)
{ }

Thread::~Thread()
{
	kill();
	join();
	delete _priv;
}

void Thread::join()
{
	if(_state>=JOINED)
		return;

	platform_join();
	_state = JOINED;
}

void Thread::kill()
{
	if(_state!=RUNNING)
		return;

	platform_kill();
	_state = KILLED;
}

void Thread::launch()
{
	if(_state>=RUNNING)
		throw already_called("Thread::launch");

	platform_launch();
	_state = RUNNING;
}

ThreadReturn THREAD_CALL Thread::Private::main_wrapper(void *arg)
{
	Thread *thread = reinterpret_cast<Thread *>(arg);
	thread->platform_setname();
	thread->main();
	thread->_state = FINISHED;
	return 0;
}

} // namespace Msp
