#ifndef MSP_STRINGCODEC_JISX201_H_
#define MSP_STRINGCODEC_JISX201_H_

#include "codec.h"

namespace Msp {
namespace StringCodec {

class JisX0201: public StandardCodec<JisX0201>
{
public:
	class Encoder: public Codec::Encoder
	{
	public:
		Encoder(ErrorMode em = DEFAULT): Codec::Encoder(em) { }

		void encode_char(unichar, std::string &) override;
	private:
		void transliterate(unichar, std::string &) override;
	};

	class Decoder: public Codec::Decoder
	{
	public:
		Decoder(ErrorMode em = DEFAULT): Codec::Decoder(em) { }

		unichar decode_char(const std::string &, std::string::const_iterator &) override;
	};

	JisX0201(ErrorMode em = DEFAULT): StandardCodec<JisX0201>(em) { }

	const char *get_name() const override { return "JIS X 0201"; }
};

} // namespace StringCodec
} // namespace Msp

#endif
